//+------------------------------------------------------------------+
//|                                                  Trend Lines.mq4 |
//|                                                            Talex |
//|                                                 tan@gazinter.net |
//+------------------------------------------------------------------+
#property copyright "Talex"
#property link      "tan@gazinter.net"

#property indicator_chart_window

extern int Num=500;           // -  
extern int n=3;               //   Sup/Res 
extern int m=2;               //   
extern int Per=8;             // 
extern bool Mounth=true;      //    Sup/Res,  true
extern bool Week=true;        //    Sup/Res,  true
extern bool Days=true;        //    Sup/Res,  true
extern bool Hour4=false;      //   4-  Sup/Res,  true
extern bool Hour1=false;      //    Sup/Res,  true
extern bool Current=false;    //    Sup/Res,  true
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int i,k;
   for(i=0; i<=n-1; i++)
   {
     ObjectCreate("MonthSup_"+i,OBJ_TREND,0,0,0,0,0);
     ObjectSet("MonthSup_"+i,OBJPROP_COLOR,Red);
     ObjectSet("MonthSup_"+i,OBJPROP_RAY,true);
     ObjectSet("MonthSup_"+i,OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);
     ObjectCreate("MonthRes_"+i,OBJ_TREND,0,0,0,0,0);
     ObjectSet("MonthRes_"+i,OBJPROP_COLOR,Red);
     ObjectSet("MonthRes_"+i,OBJPROP_RAY,true);
     ObjectSet("MonthRes_"+i,OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);
     ObjectCreate("WeekSup_"+i,OBJ_TREND,0,0,0,0,0);
     ObjectSet("WeekSup_"+i,OBJPROP_COLOR,Blue);
     ObjectSet("WeekSup_"+i,OBJPROP_RAY,true);
     ObjectSet("WeekSup_"+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1  | OBJ_PERIOD_W1);
     ObjectCreate("WeekRes_"+i,OBJ_TREND,0,0,0,0,0);
     ObjectSet("WeekRes_"+i,OBJPROP_COLOR,Blue);
     ObjectSet("WeekRes_"+i,OBJPROP_RAY,true);
     ObjectSet("WeekRes_"+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1  | OBJ_PERIOD_W1);
     ObjectCreate("DaySup_"+i,OBJ_TREND,0,0,0,0,0);
     ObjectSet("DaySup_"+i,OBJPROP_COLOR,Lime);
     ObjectSet("DaySup_"+i,OBJPROP_RAY,true);
     ObjectSet("DaySup_"+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1);
     ObjectCreate("DayRes_"+i,OBJ_TREND,0,0,0,0,0);
     ObjectSet("DayRes_"+i,OBJPROP_COLOR,Lime);
     ObjectSet("DayRes_"+i,OBJPROP_RAY,true);
     ObjectSet("DayRes_"+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1);
     ObjectCreate("H4Sup_"+i,OBJ_TREND,0,0,0,0,0);
     ObjectSet("H4Sup_"+i,OBJPROP_COLOR,Aqua);
     ObjectSet("H4Sup_"+i,OBJPROP_RAY,true);
     ObjectSet("H4Sup_"+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4);
     ObjectCreate("H4Res_"+i,OBJ_TREND,0,0,0,0,0);
     ObjectSet("H4Res_"+i,OBJPROP_COLOR,Aqua);
     ObjectSet("H4Res_"+i,OBJPROP_RAY,true);
     ObjectSet("H4Res_"+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4);
     ObjectCreate("H1Sup_"+i,OBJ_TREND,0,0,0,0,0);
     ObjectSet("H1Sup_"+i,OBJPROP_COLOR,Orange);
     ObjectSet("H1Sup_"+i,OBJPROP_RAY,true);
     ObjectSet("H1Sup_"+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1);
     ObjectCreate("H1Res_"+i,OBJ_TREND,0,0,0,0,0);
     ObjectSet("H1Res_"+i,OBJPROP_COLOR,Orange);
     ObjectSet("H1Res_"+i,OBJPROP_RAY,true);
     ObjectSet("H1Res_"+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1);
     ObjectCreate("Sup_"+i,OBJ_TREND,0,0,0,0,0);
     ObjectSet("Sup_"+i,OBJPROP_COLOR,Yellow);
     ObjectSet("Sup_"+i,OBJPROP_RAY,true);
     ObjectSet("Sup_"+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30);
     ObjectCreate("Res_"+i,OBJ_TREND,0,0,0,0,0);
     ObjectSet("Res_"+i,OBJPROP_COLOR,Yellow);
     ObjectSet("Res_"+i,OBJPROP_RAY,true);
     ObjectSet("Res_"+i,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30);
   }
    for(k=0; k<=m-1; k++)
    {
     ObjectCreate("MonthTrendUp_"+k,OBJ_TREND,0,0,0,0,0);
     ObjectSet("MonthTrendUp_"+k,OBJPROP_COLOR,Red);
     ObjectSet("MonthTrendUp_"+k,OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);
     ObjectCreate("MonthTrendDown_"+k,OBJ_TREND,0,0,0,0,0);
     ObjectSet("MonthTrendDown_"+k,OBJPROP_COLOR,Red);
     ObjectSet("MonthTrendDown_"+k,OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);
     ObjectCreate("WeekTrendUp_"+k,OBJ_TREND,0,0,0,0,0);
     ObjectSet("WeekTrendUp_"+k,OBJPROP_COLOR,Blue);
     ObjectSet("WeekTrendUp_"+k,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1  | OBJ_PERIOD_W1);
     ObjectCreate("WeekTrendDown_"+k,OBJ_TREND,0,0,0,0,0);
     ObjectSet("WeekTrendDown_"+k,OBJPROP_COLOR,Blue);
     ObjectSet("WeekTrendDown_"+k,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1  | OBJ_PERIOD_W1);
     ObjectCreate("DayTrendUp_"+k,OBJ_TREND,0,0,0,0,0);
     ObjectSet("DayTrendUp_"+k,OBJPROP_COLOR,Lime);
     ObjectSet("DayTrendUp_"+k,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1);
     ObjectCreate("DayTrendDown_"+k,OBJ_TREND,0,0,0,0,0);
     ObjectSet("DayTrendDown_"+k,OBJPROP_COLOR,Lime);
     ObjectSet("DayTrendDown_"+k,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1);
     ObjectCreate("H4TrendUp_"+k,OBJ_TREND,0,0,0,0,0);
     ObjectSet("H4TrendUp_"+k,OBJPROP_COLOR,Aqua);
     ObjectSet("H4TrendUp_"+k,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4);
     ObjectCreate("H4TrendDown_"+k,OBJ_TREND,0,0,0,0,0);
     ObjectSet("H4TrendDown_"+k,OBJPROP_COLOR,Aqua);
     ObjectSet("H4TrendDown_"+k,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4);
     ObjectCreate("H1TrendUp_"+k,OBJ_TREND,0,0,0,0,0);
     ObjectSet("H1TrendUp_"+k,OBJPROP_COLOR,Orange);
     ObjectSet("H1TrendUp_"+k,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1);
     ObjectCreate("H1TrendDown_"+k,OBJ_TREND,0,0,0,0,0);
     ObjectSet("H1TrendDown_"+k,OBJPROP_COLOR,Orange);
     ObjectSet("H1TrendDown_"+k,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1);
     ObjectCreate("TrendUp_"+k,OBJ_TREND,0,0,0,0,0);
     ObjectSet("TrendUp_"+k,OBJPROP_COLOR,Yellow);
     ObjectSet("TrendUp_"+k,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30);
     ObjectCreate("TrendDown_"+k,OBJ_TREND,0,0,0,0,0);
     ObjectSet("TrendDown_"+k,OBJPROP_COLOR,Yellow);
     ObjectSet("TrendDown_"+k,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30);
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  int i,k;
  for (i=0; i<=n-1; i++) 
  {
    ObjectDelete("MonthSup_"+i);
    ObjectDelete("MonthRes_"+i);
    ObjectDelete("WeekSup_"+i);
    ObjectDelete("WeekRes_"+i);
    ObjectDelete("DaySup_"+i);
    ObjectDelete("DayRes_"+i);
    ObjectDelete("H4Sup_"+i);
    ObjectDelete("H4Res_"+i);
    ObjectDelete("H1Sup_"+i);
    ObjectDelete("H1Res_"+i);
    ObjectDelete("Sup_"+i);
    ObjectDelete("Res_"+i);
  }
  
  for(k=0; k<=m-1; k++)
    {
     ObjectDelete("MonthTrendUp_"+k);
     ObjectDelete("MonthTrendDown_"+k);
     ObjectDelete("WeekTrendUp_"+k);
     ObjectDelete("WeekTrendDown_"+k);
     ObjectDelete("DayTrendUp_"+k);
     ObjectDelete("DayTrendDown_"+k);
     ObjectDelete("H4TrendUp_"+k);
     ObjectDelete("H4TrendDown_"+k);
     ObjectDelete("H1TrendUp_"+k);
     ObjectDelete("H1TrendDown_"+k);
     ObjectDelete("TrendUp_"+k);
     ObjectDelete("TrendDown_"+k);
     }
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    cbars=IndicatorCounted();
   int j;
   double MNs1,MNs2,MNs3,MNs4,MNs5,MNs6;  datetime MNst1,MNst2,MNst3,MNst4,MNst5,MNst6;
   double MNr1,MNr2,MNr3,MNr4,MNr5,MNr6;  datetime MNrt1,MNrt2,MNrt3,MNrt4,MNrt5,MNrt6;
   double Ws1,Ws2,Ws3,Ws4,Ws5,Ws6;   datetime Wst1,Wst2,Wst3,Wst4,Wst5,Wst6;
   double Wr1,Wr2,Wr3,Wr4,Wr5,Wr6;   datetime Wrt1,Wrt2,Wrt3,Wrt4,Wrt5,Wrt6;
   double Ds1,Ds2,Ds3,Ds4,Ds5,Ds6;   datetime Dst1,Dst2,Dst3,Dst4,Dst5,Dst6;
   double Dr1,Dr2,Dr3,Dr4,Dr5,Dr6;   datetime Drt1,Drt2,Drt3,Drt4,Drt5,Drt6;
   double H4s1,H4s2,H4s3,H4s4,H4s5,H4s6;   datetime H4st1,H4st2,H4st3,H4st4,H4st5,H4st6;
   double H4r1,H4r2,H4r3,H4r4,H4r5,H4r6;   datetime H4rt1,H4rt2,H4rt3,H4rt4,H4rt5,H4rt6;
   double H1s1,H1s2,H1s3,H1s4,H1s5,H1s6;   datetime H1st1,H1st2,H1st3,H1st4,H1st5,H1st6;
   double H1r1,H1r2,H1r3,H1r4,H1r5,H1r6;   datetime H1rt1,H1rt2,H1rt3,H1rt4,H1rt5,H1rt6;
   double Cur_s1,Cur_s2,Cur_s3,Cur_s4,Cur_s5,Cur_s6;   datetime Cur_st1,Cur_st2,Cur_st3,Cur_st4,Cur_st5,Cur_st6;
   double Cur_r1,Cur_r2,Cur_r3,Cur_r4,Cur_r5,Cur_r6;   datetime Cur_rt1,Cur_rt2,Cur_rt3,Cur_rt4,Cur_rt5,Cur_rt6;
   int b=/*MathRound(Per/2)*/2;
  
 
  if(Mounth==true)
{  
  int Num1=Num;
  if(iBars(NULL,PERIOD_MN1)<Num1) Num1=iBars(NULL,PERIOD_MN1)-Per;
  Print("Num1 =",Num1); 
  for(j=Num1; j>=0; j--)
  {
   if(iLow(NULL,PERIOD_MN1,j+b) == iLow(NULL,PERIOD_MN1,Lowest(NULL,PERIOD_MN1,MODE_LOW,Per,j)))
      {
      MNs6=MNs5; MNs5=MNs4; MNs4=MNs3; MNs3=MNs2; MNs2=MNs1; MNs1=iLow(NULL,PERIOD_MN1,j+b);
      MNst6=MNst5; MNst5=MNst4; MNst4=MNst3; MNst3=MNst2; MNst2=MNst1; MNst1=iTime(NULL,PERIOD_MN1,j+b);
      if(Period()<43200)
        {if(Period()==10080) MNst1=iTime(NULL,10080,Lowest(NULL,10080,MODE_LOW,5,iBarShift(NULL,10080,MNst1,false)-5));
         if(Period()==1440) MNst1=iTime(NULL,1440,Lowest(NULL,1440,MODE_LOW,25,iBarShift(NULL,1440,MNst1,false)-25));
         if(Period()==240) MNst1=iTime(NULL,240,Lowest(NULL,240,MODE_LOW,150,iBarShift(NULL,240,MNst1,false)-150));
         if(Period()==60) MNst1=iTime(NULL,60,Lowest(NULL,60,MODE_LOW,600,iBarShift(NULL,60,MNst1,false)-600));
         if(Period()==30) MNst1=iTime(NULL,30,Lowest(NULL,30,MODE_LOW,1200,iBarShift(NULL,30,MNst1,false)-1200));
         if(Period()==15) MNst1=iTime(NULL,15,Lowest(NULL,15,MODE_LOW,2400,iBarShift(NULL,15,MNst1,false)-2400));
         if(Period()==5) MNst1=iTime(NULL,5,Lowest(NULL,5,MODE_LOW,7200,iBarShift(NULL,5,MNst1,false)-7200));
         if(Period()==1) MNst1=iTime(NULL,1,Lowest(NULL,1,MODE_LOW,36000,iBarShift(NULL,1,MNst1,false)-36000));
        }
      }
   if(iHigh(NULL,PERIOD_MN1,j+b) == iHigh(NULL,PERIOD_MN1,Highest(NULL,PERIOD_MN1,MODE_HIGH,Per,j)))
      {
      MNr6=MNr5; MNr5=MNr4; MNr4=MNr3; MNr3=MNr2; MNr2=MNr1; MNr1=iHigh(NULL,PERIOD_MN1,j+b);
      MNrt6=MNrt5; MNrt5=MNrt4; MNrt4=MNrt3; MNrt3=MNrt2; MNrt2=MNrt1; MNrt1=iTime(NULL,PERIOD_MN1,j+b);
      if(Period()<43200)
        {if(Period()==10080) MNrt1=iTime(NULL,10080,Highest(NULL,10080,MODE_HIGH,5,iBarShift(NULL,10080,MNrt1,false)-5));
         if(Period()==1440) MNrt1=iTime(NULL,1440,Highest(NULL,1440,MODE_HIGH,25,iBarShift(NULL,1440,MNrt1,false)-25));
         if(Period()==240) MNrt1=iTime(NULL,240,Highest(NULL,240,MODE_HIGH,150,iBarShift(NULL,240,MNrt1,false)-150));
         if(Period()==60) MNrt1=iTime(NULL,60,Highest(NULL,60,MODE_HIGH,600,iBarShift(NULL,60,MNrt1,false)-600));
         if(Period()==30) MNrt1=iTime(NULL,30,Highest(NULL,30,MODE_HIGH,1200,iBarShift(NULL,30,MNrt1,false)-1200));
         if(Period()==15) MNrt1=iTime(NULL,15,Highest(NULL,15,MODE_HIGH,2400,iBarShift(NULL,15,MNrt1,false)-2400));
         if(Period()==5) MNrt1=iTime(NULL,5,Highest(NULL,5,MODE_HIGH,7200,iBarShift(NULL,5,MNrt1,false)-7200));
         if(Period()==1) MNrt1=iTime(NULL,1,Highest(NULL,1,MODE_HIGH,36000,iBarShift(NULL,1,MNrt1,false)-36000));
        }
      }
   }   
}  
  if(Week==true)
{  
  int Num2=Num;
  if(iBars(NULL,PERIOD_W1)<Num2) Num2=iBars(NULL,PERIOD_W1)-Per;
  Print("Num2 =",Num2); 
  for(j=Num2; j>=0; j--)
  {  
   if(iLow(NULL,PERIOD_W1,j+b) == iLow(NULL,PERIOD_W1,Lowest(NULL,PERIOD_W1,MODE_LOW,Per,j)))
      {
      Ws6=Ws5; Ws5=Ws4; Ws4=Ws3; Ws3=Ws2; Ws2=Ws1; Ws1=iLow(NULL,PERIOD_W1,j+b);
      Wst6=Wst5; Wst5=Wst4; Wst4=Wst3; Wst3=Wst2; Wst2=Wst1; Wst1=iTime(NULL,PERIOD_W1,j+b);
      if(Period()<10080)
        {if(Period()==1440) Wst1=iTime(NULL,1440,Lowest(NULL,1440,MODE_LOW,5,iBarShift(NULL,1440,Wst1,false)-5));
         if(Period()==240) Wst1=iTime(NULL,240,Lowest(NULL,240,MODE_LOW,30,iBarShift(NULL,240,Wst1,false)-30));
         if(Period()==60) Wst1=iTime(NULL,60,Lowest(NULL,60,MODE_LOW,120,iBarShift(NULL,60,Wst1,false)-120));
         if(Period()==30) Wst1=iTime(NULL,30,Lowest(NULL,30,MODE_LOW,240,iBarShift(NULL,30,Wst1,false)-240));
         if(Period()==15) Wst1=iTime(NULL,15,Lowest(NULL,15,MODE_LOW,480,iBarShift(NULL,15,Wst1,false)-480));
         if(Period()==5) Wst1=iTime(NULL,5,Lowest(NULL,5,MODE_LOW,1440,iBarShift(NULL,5,Wst1,false)-1440));
         if(Period()==1) Wst1=iTime(NULL,1,Lowest(NULL,1,MODE_LOW,7200,iBarShift(NULL,1,Wst1,false)-7200));
        }
      }
   if(iHigh(NULL,PERIOD_W1,j+b) == iHigh(NULL,PERIOD_W1,Highest(NULL,PERIOD_W1,MODE_HIGH,Per,j)))
      {
      Wr6=Wr5; Wr5=Wr4; Wr4=Wr3; Wr3=Wr2; Wr2=Wr1; Wr1=iHigh(NULL,PERIOD_W1,j+b);
      Wrt6=Wrt5; Wrt5=Wrt4; Wrt4=Wrt3; Wrt3=Wrt2; Wrt2=Wrt1; Wrt1=iTime(NULL,PERIOD_W1,j+b);
      if(Period()<10080)
        {if(Period()==1440) Wrt1=iTime(NULL,1440,Highest(NULL,1440,MODE_HIGH,5,iBarShift(NULL,1440,Wrt1,false)-5));
         if(Period()==240) Wrt1=iTime(NULL,240,Highest(NULL,240,MODE_HIGH,30,iBarShift(NULL,240,Wrt1,false)-30));
         if(Period()==60) Wrt1=iTime(NULL,60,Highest(NULL,60,MODE_HIGH,120,iBarShift(NULL,60,Wrt1,false)-120));
         if(Period()==30) Wrt1=iTime(NULL,30,Highest(NULL,30,MODE_HIGH,240,iBarShift(NULL,30,Wrt1,false)-240));
         if(Period()==15) Wrt1=iTime(NULL,15,Highest(NULL,15,MODE_HIGH,480,iBarShift(NULL,15,Wrt1,false)-480));
         if(Period()==5) Wrt1=iTime(NULL,5,Highest(NULL,5,MODE_HIGH,1440,iBarShift(NULL,5,Wrt1,false)-1440));
         if(Period()==1) Wrt1=iTime(NULL,1,Highest(NULL,1,MODE_HIGH,7200,iBarShift(NULL,1,Wrt1,false)-7200));
        }
      }
  }
}
  if(Days==true)
{  
  int Num3=Num;
  if(iBars(NULL,PERIOD_D1)<Num3) Num3=iBars(NULL,PERIOD_D1)-Per;
  Print("Num3 =",Num3); 
  for(j=Num3; j>=0; j--)
  {
      
   if(iLow(NULL,PERIOD_D1,j+b) == iLow(NULL,PERIOD_D1,Lowest(NULL,PERIOD_D1,MODE_LOW,Per,j)))
      {
      Ds6=Ds5; Ds5=Ds4; Ds4=Ds3; Ds3=Ds2; Ds2=Ds1; Ds1=iLow(NULL,PERIOD_D1,j+b);
      Dst6=Dst5; Dst5=Dst4; Dst4=Dst3; Dst3=Dst2; Dst2=Dst1; Dst1=iTime(NULL,PERIOD_D1,j+b);
      if(Period()<1440)
        {if(Period()==240) Dst1=iTime(NULL,240,Lowest(NULL,240,MODE_LOW,6,iBarShift(NULL,240,Dst1,false)-6));
         if(Period()==60) Dst1=iTime(NULL,60,Lowest(NULL,60,MODE_LOW,24,iBarShift(NULL,60,Dst1,false)-24));
         if(Period()==30) Dst1=iTime(NULL,30,Lowest(NULL,30,MODE_LOW,48,iBarShift(NULL,30,Dst1,false)-48));
         if(Period()==15) Dst1=iTime(NULL,15,Lowest(NULL,15,MODE_LOW,96,iBarShift(NULL,15,Dst1,false)-96));
         if(Period()==5) Dst1=iTime(NULL,5,Lowest(NULL,5,MODE_LOW,288,iBarShift(NULL,5,Dst1,false)-288));
         if(Period()==1) Dst1=iTime(NULL,1,Lowest(NULL,1,MODE_LOW,1440,iBarShift(NULL,1,Dst1,false)-1440));
        }
      }
   if(iHigh(NULL,PERIOD_D1,j+b) == iHigh(NULL,PERIOD_D1,Highest(NULL,PERIOD_D1,MODE_HIGH,Per,j)))
      {
      Dr6=Dr5; Dr5=Dr4; Dr4=Dr3; Dr3=Dr2; Dr2=Dr1; Dr1=iHigh(NULL,PERIOD_D1,j+b);
      Drt6=Drt5; Drt5=Drt4; Drt4=Drt3; Drt3=Drt2; Drt2=Drt1; Drt1=iTime(NULL,PERIOD_D1,j+b);
      if(Period()<1440)
        {if(Period()==240) Drt1=iTime(NULL,240,Highest(NULL,240,MODE_HIGH,6,iBarShift(NULL,240,Drt1,false)-6));
         if(Period()==60) Drt1=iTime(NULL,60,Highest(NULL,60,MODE_HIGH,24,iBarShift(NULL,60,Drt1,false)-24));
         if(Period()==30) Drt1=iTime(NULL,30,Highest(NULL,30,MODE_HIGH,48,iBarShift(NULL,30,Drt1,false)-48));
         if(Period()==15) Drt1=iTime(NULL,15,Highest(NULL,15,MODE_HIGH,96,iBarShift(NULL,15,Drt1,false)-96));
         if(Period()==5) Drt1=iTime(NULL,5,Highest(NULL,5,MODE_HIGH,288,iBarShift(NULL,5,Drt1,false)-288));
         if(Period()==1) Drt1=iTime(NULL,1,Highest(NULL,1,MODE_HIGH,1440,iBarShift(NULL,1,Drt1,false)-1440));
        }
      }
  }
}
  if(Hour4==true)
{
  int Num5=Num;
  if(iBars(NULL,PERIOD_H4)<Num5) Num5=iBars(NULL,PERIOD_H4)-Per;
 for(j=Num5; j>=0; j--)
  {
      
   if(iLow(NULL,PERIOD_H4,j+b) == iLow(NULL,PERIOD_H4,Lowest(NULL,PERIOD_H4,MODE_LOW,Per,j)))
      {
      H4s6=H4s5; H4s5=H4s4; H4s4=H4s3; H4s3=H4s2; H4s2=H4s1; H4s1=iLow(NULL,PERIOD_H4,j+b);
      H4st6=H4st5; H4st5=H4st4; H4st4=H4st3; H4st3=H4st2; H4st2=H4st1; H4st1=iTime(NULL,PERIOD_H4,j+b);
      if(Period()<240)
        {if(Period()==60) H4st1=iTime(NULL,60,Lowest(NULL,60,MODE_LOW,4,iBarShift(NULL,60,H4st1,false)-4));
         if(Period()==30) H4st1=iTime(NULL,30,Lowest(NULL,30,MODE_LOW,8,iBarShift(NULL,30,H4st1,false)-8));
         if(Period()==15) H4st1=iTime(NULL,15,Lowest(NULL,15,MODE_LOW,16,iBarShift(NULL,15,H4st1,false)-16));
         if(Period()==5) H4st1=iTime(NULL,5,Lowest(NULL,5,MODE_LOW,48,iBarShift(NULL,5,H4st1,false)-48));
         if(Period()==1) H4st1=iTime(NULL,1,Lowest(NULL,1,MODE_LOW,240,iBarShift(NULL,1,H4st1,false)-240));
        }
      }
   if(iHigh(NULL,PERIOD_H4,j+b) == iHigh(NULL,PERIOD_H4,Highest(NULL,PERIOD_H4,MODE_HIGH,Per,j)))
      {
      H4r6=H4r5; H4r5=H4r4; H4r4=H4r3; H4r3=H4r2; H4r2=H4r1; H4r1=iHigh(NULL,PERIOD_H4,j+b);
      H4rt6=H4rt5; H4rt5=H4rt4; H4rt4=H4rt3; H4rt3=H4rt2; H4rt2=H4rt1; H4rt1=iTime(NULL,PERIOD_H4,j+b);
      if(Period()<240)
        {if(Period()==60) H4rt1=iTime(NULL,60,Highest(NULL,60,MODE_HIGH,4,iBarShift(NULL,60,H4rt1,false)-4));
         if(Period()==30) H4rt1=iTime(NULL,30,Highest(NULL,30,MODE_HIGH,8,iBarShift(NULL,30,H4rt1,false)-8));
         if(Period()==15) H4rt1=iTime(NULL,15,Highest(NULL,15,MODE_HIGH,16,iBarShift(NULL,15,H4rt1,false)-16));
         if(Period()==5) H4rt1=iTime(NULL,5,Highest(NULL,5,MODE_HIGH,48,iBarShift(NULL,5,H4rt1,false)-48));
         if(Period()==1) H4rt1=iTime(NULL,1,Highest(NULL,1,MODE_HIGH,240,iBarShift(NULL,1,H4rt1,false)-240));
        }
      }
  }
}
  if(Hour1==true)
{
  int Num6=Num;
  if(iBars(NULL,PERIOD_H1)<Num6) Num6=iBars(NULL,PERIOD_H1)-Per;
 for(j=Num6; j>=0; j--)
  {
      
   if(iLow(NULL,PERIOD_H1,j+b) == iLow(NULL,PERIOD_H1,Lowest(NULL,PERIOD_H1,MODE_LOW,Per,j)))
      {
      H1s6=H1s5; H1s5=H1s4; H1s4=H1s3; H1s3=H1s2; H1s2=H1s1; H1s1=iLow(NULL,PERIOD_H1,j+b);
      H1st6=H1st5; H1st5=H1st4; H1st4=H1st3; H1st3=H1st2; H1st2=H1st1; H1st1=iTime(NULL,PERIOD_H1,j+b);
      if(Period()<60)
        {if(Period()==30) H1st1=iTime(NULL,30,Lowest(NULL,30,MODE_LOW,2,iBarShift(NULL,30,H1st1,false)-2));
         if(Period()==15) H1st1=iTime(NULL,15,Lowest(NULL,15,MODE_LOW,4,iBarShift(NULL,15,H1st1,false)-4));
         if(Period()==5) H1st1=iTime(NULL,5,Lowest(NULL,5,MODE_LOW,12,iBarShift(NULL,5,H1st1,false)-12));
         if(Period()==1) H1st1=iTime(NULL,1,Lowest(NULL,1,MODE_LOW,60,iBarShift(NULL,1,H1st1,false)-60));
        }
      }
   if(iHigh(NULL,PERIOD_H1,j+b) == iHigh(NULL,PERIOD_H1,Highest(NULL,PERIOD_H1,MODE_HIGH,Per,j)))
      {
      H1r6=H1r5; H1r5=H1r4; H1r4=H1r3; H1r3=H1r2; H1r2=H1r1; H1r1=iHigh(NULL,PERIOD_H1,j+b);
      H1rt6=H1rt5; H1rt5=H1rt4; H1rt4=H1rt3; H1rt3=H1rt2; H1rt2=H1rt1; H1rt1=iTime(NULL,PERIOD_H1,j+b);
      if(Period()<60)
        {if(Period()==30) H1rt1=iTime(NULL,30,Highest(NULL,30,MODE_HIGH,2,iBarShift(NULL,30,H1rt1,false)-2));
         if(Period()==15) H1rt1=iTime(NULL,15,Highest(NULL,15,MODE_HIGH,4,iBarShift(NULL,15,H1rt1,false)-4));
         if(Period()==5) H1rt1=iTime(NULL,5,Highest(NULL,5,MODE_HIGH,12,iBarShift(NULL,5,H1rt1,false)-12));
         if(Period()==1) H1rt1=iTime(NULL,1,Highest(NULL,1,MODE_HIGH,60,iBarShift(NULL,1,H1rt1,false)-60));
        }
      }
  }
}
  if(Current==true)
{  
  int Num4=Num;
  if(Bars<Num4) Num4=Bars-Per;
  Print("Num4 =",Num4); 
  for(j=Num4; j>=0; j--)
  {
      
   if(Low[j+b] == Low[Lowest(NULL,0,MODE_LOW,Per,j)])
      {
      Cur_s6=Cur_s5; Cur_s5=Cur_s4; Cur_s4=Cur_s3; Cur_s3=Cur_s2; Cur_s2=Cur_s1; Cur_s1=Low[j+b];
      Cur_st6=Cur_st5; Cur_st5=Cur_st4; Cur_st4=Cur_st3; Cur_st3=Cur_st2; Cur_st2=Cur_st1; Cur_st1=Time[j+b];
      }
   if(High[j+b] == High[Highest(NULL,0,MODE_HIGH,Per,j)])
      {
      Cur_r6=Cur_r5; Cur_r5=Cur_r4; Cur_r4=Cur_r3; Cur_r3=Cur_r2; Cur_r2=Cur_r1; Cur_r1=High[j+b];
      Cur_rt6=Cur_rt5; Cur_rt5=Cur_rt4; Cur_rt4=Cur_rt3; Cur_rt3=Cur_rt2; Cur_rt2=Cur_rt1; Cur_rt1=Time[j+b];
      }
   }
}   
   
   //---- Move Object in Chart
     
ObjectMove("MonthSup_0",0,MNst1-3000000,MNs1);
ObjectMove("MonthSup_0",1,MNst1,MNs1);
ObjectMove("MonthSup_1",0,MNst2-3000000,MNs2);
ObjectMove("MonthSup_1",1,MNst2,MNs2);
ObjectMove("MonthSup_2",0,MNst3-3000000,MNs3);
ObjectMove("MonthSup_2",1,MNst3,MNs3);
ObjectMove("MonthSup_3",0,MNst4-3000000,MNs4);
ObjectMove("MonthSup_3",1,MNst4,MNs4);
ObjectMove("MonthSup_4",0,MNst5-3000000,MNs5);
ObjectMove("MonthSup_4",1,MNst5,MNs5);
ObjectMove("MonthSup_5",0,MNst6-3000000,MNs6);
ObjectMove("MonthSup_5",1,MNst6,MNs6);
ObjectMove("MonthRes_0",0,MNrt1-3000000,MNr1);
ObjectMove("MonthRes_0",1,MNrt1,MNr1);
ObjectMove("MonthRes_1",0,MNrt2-3000000,MNr2);
ObjectMove("MonthRes_1",1,MNrt2,MNr2);
ObjectMove("MonthRes_2",0,MNrt3-3000000,MNr3);
ObjectMove("MonthRes_2",1,MNrt3,MNr3);
ObjectMove("MonthRes_3",0,MNrt4-3000000,MNr4);
ObjectMove("MonthRes_3",1,MNrt4,MNr4);
ObjectMove("MonthRes_4",0,MNrt5-3000000,MNr5);
ObjectMove("MonthRes_4",1,MNrt5,MNr5);
ObjectMove("MonthRes_5",0,MNrt6-3000000,MNr6);
ObjectMove("MonthRes_5",1,MNrt6,MNr6);

ObjectMove("WeekSup_0",0,Wst1-500000,Ws1);
ObjectMove("WeekSup_0",1,Wst1,Ws1);
ObjectMove("WeekSup_1",0,Wst2-500000,Ws2);
ObjectMove("WeekSup_1",1,Wst2,Ws2);
ObjectMove("WeekSup_2",0,Wst3-500000,Ws3);
ObjectMove("WeekSup_2",1,Wst3,Ws3);
ObjectMove("WeekSup_3",0,Wst4-500000,Ws4);
ObjectMove("WeekSup_3",1,Wst4,Ws4);
ObjectMove("WeekSup_4",0,Wst5-500000,Ws5);
ObjectMove("WeekSup_4",1,Wst5,Ws5);
ObjectMove("WeekSup_5",0,Wst6-500000,Ws6);
ObjectMove("WeekSup_5",1,Wst6,Ws6);
ObjectMove("WeekRes_0",0,Wrt1-500000,Wr1);
ObjectMove("WeekRes_0",1,Wrt1,Wr1);
ObjectMove("WeekRes_1",0,Wrt2-500000,Wr2);
ObjectMove("WeekRes_1",1,Wrt2,Wr2);
ObjectMove("WeekRes_2",0,Wrt3-500000,Wr3);
ObjectMove("WeekRes_2",1,Wrt3,Wr3);
ObjectMove("WeekRes_3",0,Wrt4-500000,Wr4);
ObjectMove("WeekRes_3",1,Wrt4,Wr4);
ObjectMove("WeekRes_4",0,Wrt5-500000,Wr5);
ObjectMove("WeekRes_4",1,Wrt5,Wr5);
ObjectMove("WeekRes_5",0,Wrt6-500000,Wr6);
ObjectMove("WeekRes_5",1,Wrt6,Wr6);

ObjectMove("DaySup_0",0,Dst1-100000,Ds1);
ObjectMove("DaySup_0",1,Dst1,Ds1);
ObjectMove("DaySup_1",0,Dst2-100000,Ds2);
ObjectMove("DaySup_1",1,Dst2,Ds2);
ObjectMove("DaySup_2",0,Dst3-100000,Ds3);
ObjectMove("DaySup_2",1,Dst3,Ds3);
ObjectMove("DaySup_3",0,Dst4-100000,Ds4);
ObjectMove("DaySup_3",1,Dst4,Ds4);
ObjectMove("DaySup_4",0,Dst5-100000,Ds5);
ObjectMove("DaySup_4",1,Dst5,Ds5);
ObjectMove("DaySup_5",0,Dst6-100000,Ds6);
ObjectMove("DaySup_5",1,Dst6,Ds6);
ObjectMove("DayRes_0",0,Drt1-100000,Dr1);
ObjectMove("DayRes_0",1,Drt1,Dr1);
ObjectMove("DayRes_1",0,Drt2-100000,Dr2);
ObjectMove("DayRes_1",1,Drt2,Dr2);
ObjectMove("DayRes_2",0,Drt3-100000,Dr3);
ObjectMove("DayRes_2",1,Drt3,Dr3);
ObjectMove("DayRes_3",0,Drt4-100000,Dr4);
ObjectMove("DayRes_3",1,Drt4,Dr4);
ObjectMove("DayRes_4",0,Drt5-100000,Dr5);
ObjectMove("DayRes_4",1,Drt5,Dr5);
ObjectMove("DayRes_5",0,Drt6-100000,Dr6);
ObjectMove("DayRes_5",1,Drt6,Dr6);

ObjectMove("H4Sup_0",0,H4st1-100000,H4s1);
ObjectMove("H4Sup_0",1,H4st1,H4s1);
ObjectMove("H4Sup_1",0,H4st2-100000,H4s2);
ObjectMove("H4Sup_1",1,H4st2,H4s2);
ObjectMove("H4Sup_2",0,H4st3-100000,H4s3);
ObjectMove("H4Sup_2",1,H4st3,H4s3);
ObjectMove("H4Sup_3",0,H4st4-100000,H4s4);
ObjectMove("H4Sup_3",1,H4st4,H4s4);
ObjectMove("H4Sup_4",0,H4st5-100000,H4s5);
ObjectMove("H4Sup_4",1,H4st5,H4s5);
ObjectMove("H4Sup_5",0,H4st6-100000,H4s6);
ObjectMove("H4Sup_5",1,H4st6,H4s6);
ObjectMove("H4Res_0",0,H4rt1-100000,H4r1);
ObjectMove("H4Res_0",1,H4rt1,H4r1);
ObjectMove("H4Res_1",0,H4rt2-100000,H4r2);
ObjectMove("H4Res_1",1,H4rt2,H4r2);
ObjectMove("H4Res_2",0,H4rt3-100000,H4r3);
ObjectMove("H4Res_2",1,H4rt3,H4r3);
ObjectMove("H4Res_3",0,H4rt4-100000,H4r4);
ObjectMove("H4Res_3",1,H4rt4,H4r4);
ObjectMove("H4Res_4",0,H4rt5-100000,H4r5);
ObjectMove("H4Res_4",1,H4rt5,H4r5);
ObjectMove("H4Res_5",0,H4rt6-100000,H4r6);
ObjectMove("H4Res_5",1,H4rt6,H4r6);

ObjectMove("H1Sup_0",0,H1st1-100000,H1s1);
ObjectMove("H1Sup_0",1,H1st1,H1s1);
ObjectMove("H1Sup_1",0,H1st2-100000,H1s2);
ObjectMove("H1Sup_1",1,H1st2,H1s2);
ObjectMove("H1Sup_2",0,H1st3-100000,H1s3);
ObjectMove("H1Sup_2",1,H1st3,H1s3);
ObjectMove("H1Sup_3",0,H1st4-100000,H1s4);
ObjectMove("H1Sup_3",1,H1st4,H1s4);
ObjectMove("H1Sup_4",0,H1st5-100000,H1s5);
ObjectMove("H1Sup_4",1,H1st5,H1s5);
ObjectMove("H1Sup_5",0,H1st6-100000,H1s6);
ObjectMove("H1Sup_5",1,H1st6,H1s6);
ObjectMove("H1Res_0",0,H1rt1-100000,H1r1);
ObjectMove("H1Res_0",1,H1rt1,H1r1);
ObjectMove("H1Res_1",0,H1rt2-100000,H1r2);
ObjectMove("H1Res_1",1,H1rt2,H1r2);
ObjectMove("H1Res_2",0,H1rt3-100000,H1r3);
ObjectMove("H1Res_2",1,H1rt3,H1r3);
ObjectMove("H1Res_3",0,H1rt4-100000,H1r4);
ObjectMove("H1Res_3",1,H1rt4,H1r4);
ObjectMove("H1Res_4",0,H1rt5-100000,H1r5);
ObjectMove("H1Res_4",1,H1rt5,H1r5);
ObjectMove("H1Res_5",0,H1rt6-100000,H1r6);
ObjectMove("H1Res_5",1,H1rt6,H1r6);

ObjectMove("Sup_0",0,Cur_st1-20000,Cur_s1);
ObjectMove("Sup_0",1,Cur_st1,Cur_s1);
ObjectMove("Sup_1",0,Cur_st2-20000,Cur_s2);
ObjectMove("Sup_1",1,Cur_st2,Cur_s2);
ObjectMove("Sup_2",0,Cur_st3-20000,Cur_s3);
ObjectMove("Sup_2",1,Cur_st3,Cur_s3);
ObjectMove("Sup_3",0,Cur_st4-20000,Cur_s4);
ObjectMove("Sup_3",1,Cur_st4,Cur_s4);
ObjectMove("Sup_4",0,Cur_st5-20000,Cur_s5);
ObjectMove("Sup_4",1,Cur_st5,Cur_s5);
ObjectMove("Sup_5",0,Cur_st6-20000,Cur_s6);
ObjectMove("Sup_5",1,Cur_st6,Cur_s6);
ObjectMove("Res_0",0,Cur_rt1-20000,Cur_r1);
ObjectMove("Res_0",1,Cur_rt1,Cur_r1);
ObjectMove("Res_1",0,Cur_rt2-20000,Cur_r2);
ObjectMove("Res_1",1,Cur_rt2,Cur_r2);
ObjectMove("Res_2",0,Cur_rt3-20000,Cur_r3);
ObjectMove("Res_2",1,Cur_rt3,Cur_r3);
ObjectMove("Res_3",0,Cur_rt4-20000,Cur_r4);
ObjectMove("Res_3",1,Cur_rt4,Cur_r4);
ObjectMove("Res_4",0,Cur_rt5-20000,Cur_r5);
ObjectMove("Res_4",1,Cur_rt5,Cur_r5);
ObjectMove("Res_5",0,Cur_rt6-20000,Cur_r6);
ObjectMove("Res_5",1,Cur_rt6,Cur_r6);


ObjectMove("MonthTrendUp_0",1,MNrt1,MNr1);
ObjectMove("MonthTrendUp_0",0,MNrt2,MNr2);
ObjectMove("MonthTrendUp_1",1,MNrt2,MNr2);
ObjectMove("MonthTrendUp_1",0,MNrt3,MNr3);
ObjectMove("MonthTrendUp_2",1,MNrt3,MNr3);
ObjectMove("MonthTrendUp_2",0,MNrt4,MNr4);
ObjectMove("MonthTrendUp_3",1,MNrt4,MNr4);
ObjectMove("MonthTrendUp_3",0,MNrt5,MNr5);
ObjectMove("MonthTrendUp_4",1,MNrt5,MNr5);
ObjectMove("MonthTrendUp_4",0,MNrt6,MNr6);

ObjectMove("WeekTrendUp_0",1,Wrt1,Wr1);
ObjectMove("WeekTrendUp_0",0,Wrt2,Wr2);
ObjectMove("WeekTrendUp_1",1,Wrt2,Wr2);
ObjectMove("WeekTrendUp_1",0,Wrt3,Wr3);
ObjectMove("WeekTrendUp_2",1,Wrt3,Wr3);
ObjectMove("WeekTrendUp_2",0,Wrt4,Wr4);
ObjectMove("WeekTrendUp_3",1,Wrt4,Wr4);
ObjectMove("WeekTrendUp_3",0,Wrt5,Wr5);
ObjectMove("WeekTrendUp_4",1,Wrt5,Wr5);
ObjectMove("WeekTrendUp_4",0,Wrt6,Wr6);

ObjectMove("DayTrendUp_0",1,Drt1,Dr1);
ObjectMove("DayTrendUp_0",0,Drt2,Dr2);
ObjectMove("DayTrendUp_1",1,Drt2,Dr2);
ObjectMove("DayTrendUp_1",0,Drt3,Dr3);
ObjectMove("DayTrendUp_2",1,Drt3,Dr3);
ObjectMove("DayTrendUp_2",0,Drt4,Dr4);
ObjectMove("DayTrendUp_3",1,Drt4,Dr4);
ObjectMove("DayTrendUp_3",0,Drt5,Dr5);
ObjectMove("DayTrendUp_4",1,Drt5,Dr5);
ObjectMove("DayTrendUp_4",0,Drt6,Dr6);

ObjectMove("H4TrendUp_0",1,H4rt1,H4r1);
ObjectMove("H4TrendUp_0",0,H4rt2,H4r2);
ObjectMove("H4TrendUp_1",1,H4rt2,H4r2);
ObjectMove("H4TrendUp_1",0,H4rt3,H4r3);
ObjectMove("H4TrendUp_2",1,H4rt3,H4r3);
ObjectMove("H4TrendUp_2",0,H4rt4,H4r4);
ObjectMove("H4TrendUp_3",1,H4rt4,H4r4);
ObjectMove("H4TrendUp_3",0,H4rt5,H4r5);
ObjectMove("H4TrendUp_4",1,H4rt5,H4r5);
ObjectMove("H4TrendUp_4",0,H4rt6,H4r6);

ObjectMove("H1TrendUp_0",1,H1rt1,H1r1);
ObjectMove("H1TrendUp_0",0,H1rt2,H1r2);
ObjectMove("H1TrendUp_1",1,H1rt2,H1r2);
ObjectMove("H1TrendUp_1",0,H1rt3,H1r3);
ObjectMove("H1TrendUp_2",1,H1rt3,H1r3);
ObjectMove("H1TrendUp_2",0,H1rt4,H1r4);
ObjectMove("H1TrendUp_3",1,H1rt4,H1r4);
ObjectMove("H1TrendUp_3",0,H1rt5,H1r5);
ObjectMove("H1TrendUp_4",1,H1rt5,H1r5);
ObjectMove("H1TrendUp_4",0,H1rt6,H1r6);

ObjectMove("TrendUp_0",1,Cur_rt1,Cur_r1);
ObjectMove("TrendUp_0",0,Cur_rt2,Cur_r2);
ObjectMove("TrendUp_1",1,Cur_rt2,Cur_r2);
ObjectMove("TrendUp_1",0,Cur_rt3,Cur_r3);
ObjectMove("TrendUp_2",1,Cur_rt3,Cur_r3);
ObjectMove("TrendUp_2",0,Cur_rt4,Cur_r4);
ObjectMove("TrendUp_3",1,Cur_rt4,Cur_r4);
ObjectMove("TrendUp_3",0,Cur_rt5,Cur_r5);
ObjectMove("TrendUp_4",1,Cur_rt5,Cur_r5);
ObjectMove("TrendUp_4",0,Cur_rt6,Cur_r6);

ObjectMove("MonthTrendDown_0",1,MNst1,MNs1);
ObjectMove("MonthTrendDown_0",0,MNst2,MNs2);
ObjectMove("MonthTrendDown_1",1,MNst2,MNs2);
ObjectMove("MonthTrendDown_1",0,MNst3,MNs3);
ObjectMove("MonthTrendDown_2",1,MNst3,MNs3);
ObjectMove("MonthTrendDown_2",0,MNst4,MNs4);
ObjectMove("MonthTrendDown_3",1,MNst4,MNs4);
ObjectMove("MonthTrendDown_3",0,MNst5,MNs5);
ObjectMove("MonthTrendDown_4",1,MNst5,MNs5);
ObjectMove("MonthTrendDown_4",0,MNst6,MNs6);

ObjectMove("WeekTrendDown_0",1,Wst1,Ws1);
ObjectMove("WeekTrendDown_0",0,Wst2,Ws2);
ObjectMove("WeekTrendDown_1",1,Wst2,Ws2);
ObjectMove("WeekTrendDown_1",0,Wst3,Ws3);
ObjectMove("WeekTrendDown_2",1,Wst3,Ws3);
ObjectMove("WeekTrendDown_2",0,Wst4,Ws4);
ObjectMove("WeekTrendDown_3",1,Wst4,Ws4);
ObjectMove("WeekTrendDown_3",0,Wst5,Ws5);
ObjectMove("WeekTrendDown_4",1,Wst5,Ws5);
ObjectMove("WeekTrendDown_4",0,Wst6,Ws6);

ObjectMove("DayTrendDown_0",1,Dst1,Ds1);
ObjectMove("DayTrendDown_0",0,Dst2,Ds2);
ObjectMove("DayTrendDown_1",1,Dst2,Ds2);
ObjectMove("DayTrendDown_1",0,Dst3,Ds3);
ObjectMove("DayTrendDown_2",1,Dst3,Ds3);
ObjectMove("DayTrendDown_2",0,Dst4,Ds4);
ObjectMove("DayTrendDown_3",1,Dst4,Ds4);
ObjectMove("DayTrendDown_3",0,Dst5,Ds5);
ObjectMove("DayTrendDown_4",1,Dst5,Ds5);
ObjectMove("DayTrendDown_4",0,Dst6,Ds6);

ObjectMove("H4TrendDown_0",1,H4st1,H4s1);
ObjectMove("H4TrendDown_0",0,H4st2,H4s2);
ObjectMove("H4TrendDown_1",1,H4st2,H4s2);
ObjectMove("H4TrendDown_1",0,H4st3,H4s3);
ObjectMove("H4TrendDown_2",1,H4st3,H4s3);
ObjectMove("H4TrendDown_2",0,H4st4,H4s4);
ObjectMove("H4TrendDown_3",1,H4st4,H4s4);
ObjectMove("H4TrendDown_3",0,H4st5,H4s5);
ObjectMove("H4TrendDown_4",1,H4st5,H4s5);
ObjectMove("H4TrendDown_4",0,H4st6,H4s6);

ObjectMove("H1TrendDown_0",1,H1st1,H1s1);
ObjectMove("H1TrendDown_0",0,H1st2,H1s2);
ObjectMove("H1TrendDown_1",1,H1st2,H1s2);
ObjectMove("H1TrendDown_1",0,H1st3,H1s3);
ObjectMove("H1TrendDown_2",1,H1st3,H1s3);
ObjectMove("H1TrendDown_2",0,H1st4,H1s4);
ObjectMove("H1TrendDown_3",1,H1st4,H1s4);
ObjectMove("H1TrendDown_3",0,H1st5,H1s5);
ObjectMove("H1TrendDown_4",1,H1st5,H1s5);
ObjectMove("H1TrendDown_4",0,H1st6,H1s6);

ObjectMove("TrendDown_0",1,Cur_st1,Cur_s1);
ObjectMove("TrendDown_0",0,Cur_st2,Cur_s2);
ObjectMove("TrendDown_1",1,Cur_st2,Cur_s2);
ObjectMove("TrendDown_1",0,Cur_st3,Cur_s3);
ObjectMove("TrendDown_2",1,Cur_st3,Cur_s3);
ObjectMove("TrendDown_2",0,Cur_st4,Cur_s4);
ObjectMove("TrendDown_3",1,Cur_st4,Cur_s4);
ObjectMove("TrendDown_3",0,Cur_st5,Cur_s5);
ObjectMove("TrendDown_4",1,Cur_st5,Cur_s5);
ObjectMove("TrendDown_4",0,Cur_st6,Cur_s6);
//----
   return(0);
  }
//-----------------------------------------------

